Wie kann man die Bundesstatistik für einen Laien konfigurierbar machen?




Dreh- und Angelpunkt ist eine Jsondatei (JD), die prinzipiell die Bundesstatistik definiert.
Für die Bearbeitung der Jsondatei könnte es eine HTML-GUI geben. Aber für das POC genügt es, 
das Format der Jsondatei zu definieren und die Operationen darauf festzulegen.


Was muss die Jsondatei leisten?

Die Jsondatei (JD) kann auch eine Pythonstruktur sein.


Template
-------

Ein HTML-Template erzeugen, dass in EBKuS zur Darstellung einer Bundesstatistikinstanz verwendet wird.
Für jedes Berichtsjahr ist eine eigene Version zu erzeugen.

--> in jghstatistik wirde JD benutzt statt _fb_data, bzw eine Instanz von JGHDefinition()


Datenbankupdate
---------------

Mit den Informationen aus der Jsondatei sollte man die Datenbank updaten können, so dass alle Daten aus 
der Statistik in dieser abgelegt werden können (jghstat07).

Außerdem die Metadatenbank (tabelle, feld).
Außerdem sollen die Merkmale updatet werden können (kategorie, code).


Der Datenbankupdate sollte möglichst so geschehen, dass die früheren HTML-Templates, Statistikexporte 
und Statistikabfragen weiterhin funktionieren.

--> in update eine Methode, die bei jedem Aufruf JD abarbeitet und die Datenbank bei Bedarf anpasst.



Bundesstatistikexport
---------------

Anhand der Jsondatei und mit den gespeicherten Daten für eine Instanz sollte der zu exportierende
Datensatz erzeugt werden können.

--> In jghexport wird JD benutzt anstatt die jetzige Klasse


Statistikauswertung
-------------------

Die Statistiken, die EBKuS selber ausgibt, sollten adäquat unterstützt werden.

??


Validierung
-----------

Aus der Jsondatei sollten auch die notwendigen Validierungen ableitbar sein (ebupd.py).

--> _jgh07_check benutzt JD


Übernommene Daten
-----------------

Die Jsondatei sollte auch definieren, welche Items der Bundesstatistik aus bereits vorhandenen Daten 
mit einem Wert vorbelegt werden sollen und ob dieser Wert noch modifizierbar sein soll.

--> wird in jghstatistik berücksichtig


Kontrollfluss
-------------

Falls in der Bundesstatistik Abhängigkeiten definiert werden, z.B. das bestimmte Fragen nur dann beantwortet
werden dürfen/müssen, wenn eine andere Frage in einer bestimmte Weise beantwortet wurde.


--> wird in ebupd._jgh07_check berücksichtigt

Systemintegration
-----------------

Für jedes Berichtsjahr gibt es eine neue JD. Die ist orthogonal zur EBKuS-Version.

Hypthothese:
Das ganze so einrichten, dass bei jedem Neustart geprüft wird, ob etwas getan werden, muss zB die
Datenbank updaten.

--> jghdef_<jahr>.json in lib/ebkus/app/jghdef für jedes Jahr


GUI für Generierung der JD
--------------------------

Die Gui (HTML) hat Zugriff auf die JD vom Vorjahr und erzeugt die neue JD. Die JD wird in 
einem Ordner lib/ebkus/app/bundesstatistik ablegt unter dem Namen jghdef_<jahr>.py.

--> evt. zunächst eine kleine Testanwendung, wo man die neue Statistik testen kann.
