Item: ein einzelne Frage oder ein Eingabeelement eines Formulars für die Datenerfassung
Abschnitt: eine Gruppierung von Items
Merkmal: Menge von Merkmalsausprägungen für ein Item und dem dazugehörigen Code

Bundesstatistik
	berichtsjahr:int
	export_datensatz_laenge:int
	merkmale:list
	merkmale_by_name
	abschnitte:list
	abschnitte_by_name:dict
	
Merkmal
	name:str
	bezeichnung:str
	auspraegungen:list

Auspraegung
	code:str
	bezeichnung:str
	von:int
	bis:int
	
Abschnitt
	name:str
	titel:str
	typ:str {standard, kopf, text}
	text:str, nur bei text. 
	fett:bool, nur bei text. {true, false}
	items:list, nicht bei text


Items
	label:str
	typ:str {text, merkmal, int}
	text:str, nur bei text. 
	fett:bool, nur bei text. {true, false}
	min:int, nur bei int
	max:int, nur bei int
	merkmal:str, nur bei kat
	readonly:bool
	hidden:bool
	export_datensatz_von:int
	export_datensatz_bis:int
	wireb_name:str
	wireb_nummer:int
	datenbank_feld:str
	function:function
	default:str
