import pytest



@pytest.fixture
def param1():
    return 22


def test_t(param1, tmpdir):
    print param1
    print tmpdir
    assert param1 == 22

def test_path(ebkus_home):
    assert ebkus_home == '/home/data/dev/ebkus/ebkus_test/ebkus'


def test_ectl(ebkus_control):
    print ebkus_control.snapshot_path
    assert ebkus_control.snapshot_path


def test_initialize(initialize_test_database):
    assert initialize_test_database == 1

def test_daten(test_daten):
    assert test_daten
    res = test_daten.miteinf(ben='atms', stz="A", benr='bearb')
    assert res['ben'] == 'atms'

def test_interact(interact):
    assert interact

def test_login_menu_logout(interact):
    #assert initialize_test_database
    assert interact.login('Admin', 'Admin') == True
    r = interact.get('menu')
    assert interact.check_error(r, is_in_title='Administratorhaupt')
    #r = interact.submit('updmit', mitid=1, na='SchmiedelXX')
    #r = interact.get('updmit', params={'mitid':[1]})
    #print r.status_code, r.text
    assert interact.logout() == True

def test_einrichten(interact):
    pass
